﻿using System;

namespace PortableLibrary
{
    // Here are some portable public type declarations that will be used from a platform-dependent app.

    public class Portable<T> where T : IComparable { }

    public interface IPortable
    {
        void PortableMethod();
    }

    public delegate void PortableEventHandler(IPortable sender, EventArgs e);

    public class Portable
    {
        public void InvokePortableEvent(IPortable source)
        {
            if (PortableEvent != null)
            {
                PortableEvent(source, new EventArgs());
            }
        }

        public event PortableEventHandler PortableEvent;
    }

    [AttributeUsage(AttributeTargets.All, AllowMultiple = true)]
    public class PortableAttribute : Attribute { }
}
