﻿using System;
using PortableLibrary;

namespace WinFormsApp
{
    // Here is a WinForms-specific use of the PortableLibrary code.
    // R# EAP Build 2011-04-11 reports 5 false positives, while C# has no complaints.
    // I expect there are probably many more similar false positives, all steming from the same
    // root cause: comparing BCL types from different frameworks.

    static class Program
    {
        [STAThread]
        static void Main()
        {
            new Portable<PlatformEnum>(); // R# false positive: Type must be convertible to IComparable.

            var p = new Portable();
            p.PortableEvent += PlatformEventHandler; // R# false positive: Expected a method with ... signature.
        }

        [Portable] // R# false positive: Portable is not an attribute.
        [PortableAttribute] // R# false positive: PortableAttribute is not an attribute.
        static void PlatformEventHandler(IPortable sender, EventArgs e) { }

        public enum PlatformEnum { A, B, C }

        public class PlatformClass : IPortable
        {
            public void PortableMethod() // R# false positive: Return type should be void.
            {
                throw new NotImplementedException();
            }
        }
    }
}
